django_project/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path("", include("myg.urls")),
    path("admin/", admin.site.urls),
    path("accounts/", include("users.urls")),
    path("accounts/", include("django.contrib.auth.urls")),
]

myg/urls.py
"""myg app URL."""
from django.urls import path

from myg import views

app_name = "myg"

urlpatterns = [
    path("", views.CourseList.as_view(), name="course-list"),
    path("course/add/", views.CourseCreate.as_view(), name="course-create"),
    path("course/<int:pk>/", views.CourseDetail.as_view(), name="course-detail"),
    path("course/<int:pk>/update", views.CourseUpdate.as_view(), name="course-update"),
    path(
        "course/<int:course_id>/assessment/",
        views.AssessmentList.as_view(),
        name="assessment-list",
    ),
    path(
        "course/<int:course_id>/assessment/add/",
        views.AssesmentCreate.as_view(),
        name="assessment-create",
    ),
    path(
        "course/<int:course_id>/assessment/<int:pk>/",
        views.AssessmentDetail.as_view(),
        name="assessment-detail",
    ),
    path(
        "course/<int:course_id>/assessment/<int:pk>/update/",
        views.AssessmentUpdate.as_view(),
        name="assessment-update",
    ),
    path(
        "course/<int:pk>/enrollment/",
        views.EntrollmentList.as_view(),
        name="enrollment-list",
    ),
    path(
        "course/<int:pk>/enrollment/add/",
        views.EnrollmentCreate.as_view(),
        name="enrollment-create",
    ),
    path(
        "course/<int:course_id>/assessment/<int:assessment_id>/grades/",
        views.AssessmentGradeList.as_view(),
        name="assessment-grade-list",
    ),
    path(
        "course/<int:course_id>/assessment/<int:assessment_id>/grades/add/",
        views.AssessmentGradeCreate.as_view(),
        name="assessment-grade-create",
    ),
    path(
        "course/<int:course_id>/assessment/<int:assessment_id>/grades/<int:pk>/",
        views.GradeDetail.as_view(),
        name="grade-detail",
    ),
    path(
        "course/<int:course_id>/assessment/<int:assessment_id>/grades/<int:pk>/update/",
        views.AssessmentGradeUpdate.as_view(),
        name="assessment-grade-update",
    ),
]

myg/models.py
"""MyG models."""
from django.db import models

from users.models import CustomUser


class Course(models.Model):
    """Course model class.

    Attributes:
    ----------
    title : string
        Holds the title of the course
    semester: string
        The semester in which the course is offered.
    teacher: foreign key
        Holds a reference to the CustomUser class object.

    """

    title = models.CharField(max_length=200)
    teacher = models.ForeignKey(CustomUser, on_delete=models.CASCADE)
    students = models.ManyToManyField(CustomUser, related_name="course_students", blank=True)

    def __str__(self) -> str:
        """Return a string representation of Question."""
        return f"{self.title} offered by {self.teacher}"


class Assessment(models.Model):
    """Assesment model class.

    Attributes:
    ----------
    course : foreign key
        Holds a reference to the Course class object.
    assessment_type : string
        Holds a string that represents the type of the assesment.

    """

    class AssessmentChoices(models.IntegerChoices):
        """Assessment choice model."""

        EXAM = 1
        QUIZ = 2
        ASSIGNMENT = 3
        HOMEWORK = 4
        PROJECT = 5

    course = models.ForeignKey(Course, on_delete=models.CASCADE)
    assessment_type = models.IntegerField(
        choices=AssessmentChoices.choices, default=AssessmentChoices.PROJECT
    )
    title = models.CharField(max_length=200)
    description = models.TextField(default="")

    def __str__(self) -> str:
        """Return a string representation of assessment."""
        return f"[{self.assessment_type}] {self.title}"


class Grade(models.Model):
    """Grade model class."""

    class GradeChoices(models.TextChoices):
        """Grade choices."""

        EXCELLENT = "A"
        GOOD = "B"
        AVERAGE = "C"
        POOR = "D"

    student = models.ForeignKey(CustomUser, on_delete=models.CASCADE)
    grade = models.CharField(max_length=2, choices=GradeChoices.choices, default=GradeChoices.POOR)
    assessment = models.ForeignKey(Assessment, on_delete=models.CASCADE)

    class Meta:
        """Meta class."""

        unique_together = ("student", "assessment")

    def __str__(self) -> str:
        """Return a string representation of grade."""
        return f"{self.student}:{self.assessment}"

myg/forms.py
"""Forms for accounts app."""
from django.forms import ModelForm

from myg import models


class AssessmentGradeForm(ModelForm):
    """Registration form."""

    class Meta:
        """Meta class."""

        model = models.Grade
        fields = ("student", "grade")

myg/views.py
"""myg app views."""
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import redirect, render
from django.urls import reverse_lazy
from django.views import generic

from myg import forms, models
from users import mixins


class CourseList(generic.ListView):
    """Course list view."""

    model = models.Course


class CourseDetail(LoginRequiredMixin, generic.DetailView):
    """Course detail view."""

    model = models.Course


class CourseCreate(mixins.TeacherRequiredMixin, generic.CreateView):
    """View to create course."""

    model = models.Course
    fields = ["title"]
    success_url = reverse_lazy("myg:course-list")

    def form_valid(self, form: object) -> object:
        """Override the form valid method to store the current user as teacher."""
        course_obj = form.save(commit=False)
        course_obj.teacher = self.request.user
        return super().form_valid(form)


class CourseUpdate(mixins.TeacherRequiredMixin, generic.UpdateView):
    """View to update a Course."""

    model = models.Course
    fields = ["title"]
    success_url = reverse_lazy("myg:course-list")

    def dispatch(self, request, *args, **kwargs):
        """Override dispatch method.

        Redirect if the current user is not the owner of course.

        """
        if self.get_object().teacher != self.request.user:
            return redirect("myg:course-list")
        return super().dispatch(request, *args, **kwargs)


class AssessmentList(mixins.TeacherStudentRequiredMixin, generic.ListView):
    """Assessment list view."""

    model = models.Assessment

    def get_context_data(self, **kwargs):
        """Add additional context to display the course title in the template."""
        context = super().get_context_data(**kwargs)
        context["course"] = models.Course.objects.filter(id=self.kwargs["course_id"]).get()
        return context

    def get_queryset(self, **kwargs):
        """Only display assessments related to the current course."""
        queryset = super().get_queryset(**kwargs)
        return queryset.filter(course=self.kwargs["course_id"])


class AssesmentCreate(mixins.TeacherRequiredMixin, generic.CreateView):
    """View to create assessment."""

    model = models.Assessment
    fields = ["assessment_type", "title", "description"]

    def get_success_url(self):
        """Get success url."""
        course_id = self.kwargs["course_id"]
        return reverse_lazy("myg:assessment-list", kwargs={"course_id": course_id})

    def form_valid(self, form: object) -> object:
        """Override form valid method to store the current user as the teacher field value."""
        assessment = form.save(commit=False)
        assessment.course_id = models.Course.objects.filter(id=self.kwargs["course_id"]).get().id
        return super().form_valid(form)

    def get_context_data(self, **kwargs):
        """Add additional context to display the course title in the template."""
        context = super().get_context_data(**kwargs)
        context["course"] = models.Course.objects.filter(id=self.kwargs["course_id"]).get()
        return context


class AssessmentDetail(mixins.TeacherStudentRequiredMixin, generic.DetailView):
    """Assessment detail view."""

    model = models.Assessment

    def get_object(self, queryset=None):
        """Get the object of the assessment detail."""
        if queryset is None:
            queryset = self.get_queryset()

        return queryset.filter(course__id=self.kwargs["course_id"], id=self.kwargs["pk"]).get()

    def dispatch(self, request, *args, **kwargs):
        """Override dispatch method.

        Redirect to assessment list if the current user is not one of these two:
        1. Teacher who teaches the course.
        2. Student who has enrolled for the course.

        """
        if (
            self.request.user.is_teacher and self.get_object().course.teacher != self.request.user
        ) or (
            self.request.user.is_student
            and self.request.user not in self.get_object().course.students.all()
        ):
            return redirect(
                reverse_lazy(
                    "myg:assessment-list",
                    kwargs={"course_id": self.get_object().course.id},
                )
            )
        return super().dispatch(request, *args, **kwargs)


class AssessmentUpdate(mixins.TeacherRequiredMixin, generic.UpdateView):
    """Assessment detail Update view."""

    model = models.Assessment
    fields = ["title", "description"]

    def get_object(self, queryset=None):
        """Get the object of the assessment that is being updated."""
        if queryset is None:
            queryset = self.get_queryset()

        return queryset.filter(course__id=self.kwargs["course_id"], id=self.kwargs["pk"]).get()

    def get_success_url(self):
        """Get success url: Redirect to detail page of the assessment that is being updated."""
        return reverse_lazy(
            "myg:assessment-detail",
            kwargs={"course_id": self.get_object().course.id, "pk": self.get_object().id},
        )

    def dispatch(self, request, *args, **kwargs):
        """Dispatch method: Check if the current user is the teacher of the course."""
        if self.get_object().course.teacher != self.request.user:
            return redirect(
                reverse_lazy(
                    "myg:assessment-list",
                    kwargs={"course_id": self.get_object().course.id},
                )
            )

        return super().dispatch(request, *args, **kwargs)


class EnrollmentCreate(mixins.StudentRequiredMixin, generic.UpdateView):
    """Enroll for a course."""

    model = models.Course
    template_name = "myg/enrollment_form.html"
    fields = []

    def get_success_url(self):
        """Get success url: Redirect to detail page of the course."""
        course_id = self.kwargs["pk"]
        return reverse_lazy("myg:course-detail", kwargs={"pk": course_id})

    def form_valid(self, form: object) -> object:
        """Override form valid method to store the current user as the teacher field value."""
        course = form.save()
        course.students.add(self.request.user)
        return super().form_valid(form)


class EntrollmentList(mixins.TeacherRequiredMixin, generic.DetailView):
    """List of enrolled students."""

    model = models.Course
    template_name = "myg/enrollment_list.html"


class AssessmentGradeCreate(mixins.TeacherRequiredMixin, generic.FormView):
    """View to create or upgrade grade for an assessment."""

    form_class = forms.AssessmentGradeForm
    fields = ["student", "grade"]
    template_name = "myg/assessment_grade_form.html"

    def get_form(self, *args, **kwargs):
        """In the form, only display registered students of the course."""
        form = super().get_form(*args, **kwargs)
        course = models.Course.objects.filter(id=self.kwargs["course_id"]).get()
        form.fields["student"].queryset = course.students.all()
        return form

    def get_context_data(self, **kwargs):
        """Add additional context to display the course and assessment title in the template."""
        context = super().get_context_data(**kwargs)
        context["assessment"] = models.Assessment.objects.filter(id=self.kwargs["course_id"]).get()
        context["course"] = models.Course.objects.filter(id=self.kwargs["course_id"]).get()
        return context

    def post(self, request, *args, **kwargs):
        """Override get method to check if given data already exists, then redirect."""
        assessment_id = self.kwargs["assessment_id"]
        course_id = self.kwargs["course_id"]
        form = self.form_class(request.POST)

        if form.is_valid():
            student_id = form.cleaned_data.get("student").id
            grade = form.cleaned_data.get("grade")

            models.Grade.objects.update_or_create(
                assessment_id=assessment_id, student_id=student_id, grade=grade
            )

            return redirect(
                reverse_lazy(
                    "myg:assessment-list",
                    kwargs={"course_id": course_id},
                )
            )

        return render(request, self.template_name, {"form": form})

    def get_success_url(self):
        """Get success url."""
        course_id = self.kwargs["course_id"]
        assessment_id = self.kwargs["assessment_id"]
        return reverse_lazy(
            "myg:assessment-grade-list",
            kwargs={"course_id": course_id, "assessment_id": assessment_id},
        )


class AssessmentGradeList(mixins.TeacherRequiredMixin, generic.ListView):
    """List the grades of all the assessments of a course."""

    model = models.Grade
    template_name = "myg/assessment_grade_list.html"

    def get_queryset(self, **kwargs):
        """Only display assessments related to the current course."""
        queryset = super().get_queryset(**kwargs)
        return queryset.filter(assessment_id=self.kwargs["assessment_id"])

    def get_context_data(self, **kwargs):
        """Add additional context to display the course title in the template."""
        context = super().get_context_data(**kwargs)
        context["course"] = models.Course.objects.filter(id=self.kwargs["course_id"]).get()
        context["assessment"] = models.Assessment.objects.filter(
            id=self.kwargs["assessment_id"]
        ).get()
        return context


class AssessmentGradeUpdate(mixins.TeacherRequiredMixin, generic.UpdateView):
    """Update the grade of an assessments of a course."""

    model = models.Grade
    template_name = "myg/assessment_grade_form.html"
    fields = ["student", "grade"]

    def get_form(self, *args, **kwargs):
        """In the form, only display registered students of the course."""
        form = super().get_form(*args, **kwargs)
        course = models.Course.objects.filter(id=self.kwargs["course_id"]).get()

myg/templates/myg/assessment_detail.html
{% extends "base_generic.html" %}
{% block title %}
    {{ assessment.title }}
{% endblock title %}
{% block content %}
    <div class="row justify-content-center mb-4">
        <div class="col-md-6">
            <div class="text-center">
                <a {% if user.is_authenticated and user.is_teacher and user == assessment.course.teacher %} class="btn btn-success" {% else %} class="btn btn-success disabled" {% endif %}
                   role="button"
                   href="{% url 'myg:assessment-update' course_id=assessment.course.id pk=assessment.id %}">
                    <i class="fa-solid fa-edit"></i> Edit
                </a>
                <a {% if user.is_authenticated and user.is_teacher and user == assessment.course.teacher %} class="btn btn-success" {% else %} class="btn btn-success disabled" {% endif %}
                   role="button"
                   href="{% url 'myg:assessment-grade-create' course_id=assessment.course.id assessment_id=assessment.id %}">
                    <i class="fa-solid fa-plus"></i> Grade
                </a>
                <a {% if user.is_authenticated and user.is_teacher and user == assessment.course.teacher %} class="btn btn-warning" {% else %} class="btn btn-warning disabled" {% endif %}
                   role="button"
                   href="{% url 'myg:assessment-grade-list' course_id=assessment.course.id assessment_id=assessment.id %}">
                    <i class="fa-solid fa-list"></i> Grades
                </a>
            </div>
        </div>
    </div>
    <div class="row justify-content-center mb-5">
        <div class="col-md-6">
            <ul>
                <li>Assessment: {{ assessment.title }}</li>
                <li>Course: {{ assessment.course.title }}</li>
                <li>Description: {{ assessment.description }}</li>
            </ul>
        </div>
    </div>
{% endblock content %}

myg/templates/myg/assessment_form.html
{% extends "base_generic.html" %}
{% load django_bootstrap5 %}
{% block title %}
    Create Assessment for {{ course.title }}
{% endblock title %}
{% block content %}
    <div class="d-flex justify-content-center mb-5">
        <div class="col-md-6">
            <form method="post">
                {% csrf_token %}
                {% bootstrap_form form %}
                <div class="text-center">
                    <button type="submit" class="btn btn-primary justify-center">
                        <i class="fa-solid fa-floppy-disk"></i> Save
                    </button>
                </div>
            </form>
        </div>
    </div>
{% endblock content %}

myg/templates/myg/assessment_grade_form.html
{% extends "base_generic.html" %}
{% load django_bootstrap5 %}
{% block title %}
    Add grade
{% endblock title %}
{% block content %}
    <div class="d-flex justify-content-center mb-5">
        <div class="col-md-6">
            <ul>
                <li>Course: {{ course.title }}</li>
                <li>Assessment: {{ assessment.title }}</li>
            </ul>
        </div>
    </div>
    <div class="d-flex justify-content-center mb-5">
        <div class="col-md-6">
            <form method="post">
                {% csrf_token %}
                {% bootstrap_form form %}
                <div class="text-center">
                    <button type="submit" class="btn btn-primary justify-center">
                        <i class="fa-solid fa-floppy-disk"></i> Save
                    </button>
                </div>
            </form>
        </div>
    </div>
{% endblock content %}

myg/templates/myg/assessment_grade_list.html
{% extends "base_generic.html" %}
{% block title %}
    Grades
{% endblock title %}
{% block content %}
    <div class="row justify-content-center mb-5">
        <div class="col-md-6">
            <ul>
                <li>Course: {{ course.title }}</li>
                <li>Assessment: {{ assessment.title }}</li>
            </ul>
        </div>
    </div>
    <div class="row justify-content-center mb-5">
        <div class="col-md-6">
            {% if object_list %}
                <table class="table table-striped table-bordered table-hover">
                    <thead>
                        <tr>
                            <th scope="col">Student</th>
                            <th scope="col">Grade</th>
                            <th scope="col">Edit</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for grade in object_list %}
                            <tr>
                                <td>{{ grade.student }}</td>
                                <td>{{ grade.grade }}</td>
                                <td>
                                    <a {% if user.is_authenticated and user.is_teacher %} class="btn btn-success" {% else %} class="btn btn-success disabled" {% endif %}
                                       role="button"
                                       href="{% url 'myg:assessment-grade-update' course_id=course.id assessment_id=assessment.id pk=grade.id %}">
                                        <i class="fa-solid fa-edit"></i>
                                    </a>
                                </td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            {% else %}
                <p>No Assessments are available.</p>
            {% endif %}
        </div>
    </div>
{% endblock content %}

myg/templates/myg/assessment_list.html
{% extends "base_generic.html" %}
{% block title %}
    Assessments for {{ course.title }}
{% endblock title %}
{% block content %}
    <div class="row justify-content-center mb-4">
        <div class="col-md-4">
            <div class="text-center">
                <a {% if user.is_authenticated and user.is_teacher and user == course.teacher %} class="btn btn-warning" {% else %} class="btn btn-warning disabled" {% endif %}
                   href="{% url 'myg:assessment-create' course.id %}">
                    <i class="fa-solid fa-plus"></i> Create
                </a>
            </div>
        </div>
    </div>
    <div class="row justify-content-center mb-5">
        <div class="col-md-6">
            {% if object_list %}
                <ol>
                    {% for assessment in object_list %}
                        <li>
                            <a href="{% url 'myg:assessment-detail' course_id=assessment.course.id pk=assessment.id %}">{{ assessment.title }}</a>
                        </li>
                    {% endfor %}
                </ol>
            {% else %}
                <p>No Assessments are available.</p>
            {% endif %}
        </div>
    </div>
{% endblock content %}

myg/templates/myg/course_detail.html
{% extends "base_generic.html" %}
{% block title %}
    Course: {{ course.title }}
{% endblock title %}
{% block content %}
    <div class="row justify-content-center mb-4">
        <div class="col-md-8 mb-4">
            <div class="text-center">
                <a {% if user.is_authenticated and user == course.teacher %} class="btn btn-success" {% else %} class="btn btn-success disabled" {% endif %}
                   role="button"
                   href="{% url 'myg:course-update' course.id %}">
                    <i class="fa-solid fa-edit"></i> Edit
                </a>
                <a {% if user.is_authenticated and user == course.teacher %} class="btn btn-primary" {% else %} class="btn btn-success disabled" {% endif %}
                   role="button"
                   href="{% url 'myg:enrollment-list' course.id %}">
                    <i class="fa-solid fa-list"></i> Enrollment
                </a>
            </div>
        </div>
        <div class="col-md-6">
            <ul>
                <li>Course: {{ course.title }}</li>
                <li>Teacher: {{ course.teacher }}</li>
            </ul>
        </div>
    </div>
    <div class="row justify-content-center mb-4">
        <div class="col-md-8">
            <div class="text-center">
                <a {% if user.is_authenticated and user.is_teacher or user.is_student %} class="btn btn-warning" {% else %} class="btn btn-warning disabled" {% endif %}
                   role="button"
                   href="{% url 'myg:assessment-list' course.id %}">
                    <i class="fa-solid fa-list"></i> Assessments
                </a>
                <a {% if user.is_authenticated and user.is_student %} class="btn btn-success" {% else %} class="btn btn-success disabled" {% endif %}
                   role="button"
                   href="{% url 'myg:enrollment-create' course.id %}">
                    <i class="fa-solid fa-user-plus"></i> Register
                </a>
            </div>
        </div>
    </div>
{% endblock content %}

myg/templates/myg/course_form.html
{% extends "base_generic.html" %}
{% load django_bootstrap5 %}
{% block title %}
    Add a new Course
{% endblock title %}
{% block content %}
    <div class="d-flex justify-content-center mb-5">
        <div class="col-md-6">
            <form method="post">
                {% csrf_token %}
                {% bootstrap_form form %}
                <div class="text-center">
                    <button type="submit" class="btn btn-primary justify-center">
                        <i class="fa-solid fa-floppy-disk"></i> Create
                    </button>
                </div>
            </form>
        </div>
    </div>
{% endblock content %}

myg/templates/myg/course_list.html
{% extends "base_generic.html" %}
{% block title %}
    Courses
{% endblock title %}
{% block content %}
    <div class="row justify-content-center mb-4">
        <div class="col-md-6">
            {% if object_list %}
                <ol>
                    {% for course in object_list %}
                        <li>
                            <a href="{% url 'myg:course-detail' course.id %}">{{ course.title }}</a>
                        </li>
                    {% endfor %}
                </ol>
            {% else %}
                <p>No courses are available.</p>
            {% endif %}
        </div>
    </div>
    <div class="row justify-content-center">
        <div class="col-md-4">
            <div class="text-center">
                {% if user.is_authenticated and user.is_teacher %}
                    <a class="btn btn-warning" href="{% url 'myg:course-create' %}">
                        <i class="fa-solid fa-plus"></i> Create Course
                    </a>
                {% endif %}
            </div>
        </div>
    </div>
{% endblock content %}

myg/templates/myg/enrollment_form.html
{% extends "base_generic.html" %}
{% load django_bootstrap5 %}
{% block title %}
    Course Registration
{% endblock title %}
{% block content %}
    <div class="d-flex justify-content-center">
        <div class="col-md-6">
            <div class="text-center">
                <form method="post">
                    {% csrf_token %}
                    <p>Are you sure you want to register for "{{ course.title }}"?</p>
                    {% bootstrap_form form %}
                    {{ form.media }}
                    <input class="btn btn-success" type="submit" value="Confirm" />
                    <a href="{% url 'myg:course-detail' course.id %}"
                       type="button"
                       class="btn btn-warning">Cancel</a>
                </form>
            </div>
        </div>
    </div>
{% endblock content %}

myg/templates/myg/enrollment_list.html
{% extends "base_generic.html" %}
{% block title %}
    Enrollment for {{ course.title }}
{% endblock title %}
{% block content %}
    <div class="row justify-content-center mb-4">
        <div class="col-md-6">
            {% if course.students.all %}
                <ol>
                    {% for student in course.students.all %}<li>{{ student }}</li>{% endfor %}
                </ol>
            {% else %}
                <p>No students have enrolled yet.</p>
            {% endif %}
        </div>
    </div>
{% endblock content %}